
#include "process.h"
#include "console.h"
#include "segment.h"

#include "types.h"

#define INIT_ADDR			0x40000000
#define INIT_PCB			0x40001000

#define USER1_ADDR		0x40002000
#define USER1_PCB			0x40003000
#define USER2_ADDR		0x40004000
#define USER2_PCB			0x40005000




tss_struct *cpu_tss;
task_union *init_stack;
task_struct *init_pcb;
task_struct *current;
task_struct *user1_pcb = (task_struct *)USER1_PCB;
task_struct *user2_pcb = (task_struct *)USER2_PCB;

unsigned int reg;

task_struct *task_array[MAX_TASK];

int cur_task;


void init_task_list(void)
{
	int l;
	for (l=0; l<MAX_TASK;l++) {
		task_array[l] = NULL;
	}

}


int add_task_list(task_struct *new)
{
	int l = 0;

	for (l=0; l<MAX_TASK;l++) {
		if (task_array[l] == NULL) {
			task_array[l] = new;
			return l;
		}
	}

	return -1;

}

void user2(void)
{
	char *bp = (char *)0xb8008;

	while (1) (*bp)++;
}

void init_user2(void)
{
	int l;
	unsigned char *src, *dst;
	
	// copy user1 to 0x40001fff
	caos_printf("Copy user2 process to 0x4000 4000\n");
	src = (unsigned char *)user2;
	dst = (unsigned char *)USER2_ADDR;
	for (l=0 ; l < 4096; l++) // copy one page
		*dst++ = *src++;
	
	user2_pcb->thread.eip = (unsigned int)USER2_ADDR;
	user2_pcb->thread.esp = (unsigned int)USER2_ADDR+0xffc;
	user2_pcb->thread.esp0 = (unsigned int)USER2_PCB+0xffc;
	user2_pcb->thread.cs = __USER_CS;
	user2_pcb->thread.eflags = 0x200;
	user2_pcb->thread.ss = __USER_DS;
	user2_pcb->thread.ds = __USER_DS;
	user2_pcb->thread.es = __USER_DS;
	user2_pcb->thread.fs = __USER_DS;
	user2_pcb->thread.gs = __USER_DS;

	/*
	src = (unsigned char *)user1;
	dst = (unsigned char *)USER1_ADDR;
	caos_printf("Is it same? : ");
	caos_printf("<%x %x %x %x>", *(src+0),*(src+1),*(src+2),*(src+3));
	caos_printf("<%x %x %x %x>\n", *(dst+0),*(dst+1),*(dst+2),*(dst+3));
	*/

	user2_pcb->pid = add_task_list(user2_pcb);
	caos_printf("USER2 PID = %d\n", user2_pcb->pid);

}

void user1(void)
{
	char *bp = (char *)0xb8004;
	//volatile int a = 0;

	while (1) {
		(*bp)++;
		//a++;
	}

}


void init_user1(void)
{
	int l;
	unsigned char *src, *dst;
	
	// copy user1 to 0x40001fff
	caos_printf("Copy user1 process to 0x4000 2000\n");
	src = (unsigned char *)user1;
	dst = (unsigned char *)USER1_ADDR;
	for (l=0 ; l < 4096; l++) // copy one page
		*dst++ = *src++;
	
	user1_pcb->thread.eip = (unsigned int)USER1_ADDR;
	user1_pcb->thread.esp = (unsigned int)USER1_ADDR+0xffc;
	user1_pcb->thread.esp0 = (unsigned int)USER1_PCB+0xffc;
	user1_pcb->thread.cs = __USER_CS;
	user1_pcb->thread.eflags = 0x200;
	user1_pcb->thread.ss = __USER_DS;
	user1_pcb->thread.ds = __USER_DS;
	user1_pcb->thread.es = __USER_DS;
	user1_pcb->thread.fs = __USER_DS;
	user1_pcb->thread.gs = __USER_DS;

	/*
	src = (unsigned char *)user1;
	dst = (unsigned char *)USER1_ADDR;
	caos_printf("Is it same? : ");
	caos_printf("<%x %x %x %x>", *(src+0),*(src+1),*(src+2),*(src+3));
	caos_printf("<%x %x %x %x>\n", *(dst+0),*(dst+1),*(dst+2),*(dst+3));
	*/

	user1_pcb->pid = add_task_list(user1_pcb);
	caos_printf("USER1 PID = %d\n", user1_pcb->pid);

}

unsigned int user1_regs;

unsigned int eip, cs, eflags, esp, ss;

void init(void)
{

	char *bp = (char *)0xb8000;
	volatile int a=1;

	while(1) {
		(*bp)++;
		a++;
		//if (a == 0)
		//  bp++;
	}

}

void init_process(void)
{
	int l;

	//
	// read pointer of TSS from 0x9000, somewhere over 0x9XXX
	//
	unsigned int tmp = *(unsigned int *)TSS_WHERE;
	char *src, *dst;

	// kernel mode stack & process table
	init_stack = (task_union *)INIT_PCB;
	init_pcb = (task_struct *)init_stack;

	// First process is init
	current = init_pcb;
	cur_task = 0;

	// TSS for CPU
	cpu_tss = (tss_struct *)tmp;


	caos_printf("CPU TSS is at->%x\n", 
					(unsigned int)cpu_tss, (unsigned int)init_pcb);

	// Kernel Stack segment = 0x10
	cpu_tss->ss0 = 0x10;

	// copy init function at 0x4000 0000
	caos_printf("Copy init function at 0x4000 0000\n");
	src = (char *)init;
	dst = (char *)INIT_ADDR;

	for (l=0; l < 4096; l++) // copy one page
		*dst++ = *src++;

	// setup PCB of init process
	init_pcb->thread.eip = (unsigned int)INIT_ADDR;
	init_pcb->thread.esp = (unsigned int)INIT_ADDR+0xffc;
	init_pcb->thread.esp0 = (unsigned int)INIT_PCB+0xffc;
	init_pcb->thread.cs = __USER_CS;
	init_pcb->thread.eflags = 0x200;// set only interrupt flag
	init_pcb->thread.ss = __USER_DS;
	init_pcb->thread.ds = __USER_DS;
	init_pcb->thread.es = __USER_DS;
	init_pcb->thread.fs = __USER_DS;
	init_pcb->thread.gs = __USER_DS;

	init_pcb->pid = add_task_list(init_pcb);
	caos_printf("INIT PID=%d\n", init_pcb->pid);

}



void start_init(void)
{	
	reg = (unsigned int)&(init_pcb->thread);
	caos_printf("init regs: %x\n", reg);

	asm volatile (
		"cli							\n\t"
		/* 
		 * Before load TR, TSS must be initialized.
		 * Therefore kernel stack pointer is store at cpu_tss->esp0.
		 */ 
		"mov %1, %%eax		\n\t"
		"mov %%eax, %0		\n\t"
		/* load TR with TSS selector */
		"mov $0x20, %%ax	\n\t"
		"ltr %%ax			\n\t"
		"mov %2, %%esp		\n\t"
		"popa				\n\t"
		"pop %%ds				\n\t"
		"pop %%es				\n\t"
		"pop %%fs				\n\t"
		"pop %%gs				\n\t"
		"sti						\n\t"
		"iret						\n\t"
		: "=m"(cpu_tss->esp0)
		: "m"(init_pcb->thread.esp0),"m"(reg)
	);
}
		

