
#ifndef	__PROCESS_H__
#define	__PROCESS_H__

#include "processor.h"


/* declare process's statements... */
#define	PROCESS_RUNNING				1
#define	PROCESS_INTERRUPTIBLE		2
#define	PROCESS_UNINTERRUPTIBLE		3
#define	PROCESS_STOPPED				4


#define MAX_TASK 3


#define	MAX_DEVICE_OPEN		16


/* process table... */
typedef struct _task_struct
{
	int	status;
	int	pid;
	
	unsigned int	priority;
	unsigned int	counter;

	unsigned int	sleep;

	thread_struct thread;
	
} task_struct;


#define	PROCESS_STACK_SIZE	4096

#define	NORMAL_PRIORITY		20
#define	FOREGROUND_PRIORITY	40

#define	INIT_PID	0


/*
 * Process Control Block
 * It maintains all of information about user process
 * & kernel mode stack
 */
typedef union _task_union
{
	task_struct	task;

	unsigned char	stack[ PROCESS_STACK_SIZE ];
} task_union;

void init(void);
void start_init(void);
void init_process(void);

void user1(void);
void init_user1(void);
	
void init_task_list(void);
int add_task_list(task_struct *new);

void user2(void);
void init_user2(void);


#endif
